﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Interop;
using Silverlight4_ComInterop.Business;

namespace Silverlight4_ComInterop
{
    /// <summary>
    /// Instead of recreating a good example I am using a pre-existing one.
    /// Shamelessly taken from http://www.silverlight.net/learn/videos/silverlight-4-beta-videos/com-object-access-trusted-applications/
    /// </summary>
    public partial class SendDataToExcel : UserControl
    {
       

        public SendDataToExcel()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(SendDataToExcel_Loaded);
        }

        void SendDataToExcel_Loaded(object sender, RoutedEventArgs e)
        {
            // load customers and bind to datagrid
            CustomerList.ItemsSource = SampleData.GetEntities();
        }

        bool firstTime = true;
        private void LaunchExcel(object sender, RoutedEventArgs e)
        {
            // create an instance of excel
            dynamic excel = ComAutomationFactory.CreateObject("Excel.Application");
            excel.Visible = true;  // make it visible to the user.

            // add a workbook to the instance 
            dynamic workbook = excel.workbooks;
            workbook.Add();

            dynamic sheet = excel.ActiveSheet; // get the active sheet

            dynamic cell = null;

            int i = 1;

            // iterate through our data source and populate the excel spreadsheet
            foreach (Entity item in CustomerList.ItemsSource)
            {
                cell = sheet.Cells[i, 1]; // row, column
                cell.Value = item.CustomerName;
                cell.ColumnWidth = 25;

                cell = sheet.Cells[i, 2];
                cell.Value = item.UnitSales;
                i++;
            }

            // add a chart
            dynamic sheetShapes = sheet.Shapes;
            sheetShapes.AddChart(-4100, 200, 2, 400, 300);

            // wire up an event handler to the Excel SheetChanged event
            if (firstTime)
            {
                excel.SheetChange += new SheetChangedDelegate(SheetChangedEventHandler);
                string sheetName = sheet.Name;

                firstTime = false;
            }

            ExcelButton.IsEnabled = true;
        }

        delegate void SheetChangedDelegate(dynamic excelSheet, dynamic rangeArgs);

        // event handler for the sheet changed event
        // looks at the data and creates a new items source to rebind to the datagrid
        private void SheetChangedEventHandler(dynamic excelSheet, dynamic rangeArgs)
        {
            dynamic sheet = excelSheet;

            string sheetName = sheet.Name;

            dynamic range = rangeArgs;

            dynamic rowValue = range.Row;

            Entity[] entities = CustomerList.ItemsSource as Entity[];
            Entity[] newEntities = new Entity[10];

            dynamic col2range = sheet.Range("B1:B10");

            for (int i = 0; i < 10; i++)
            {
                Entity newEntity = new Entity();
                newEntity.CustomerName = entities[i].CustomerName;
                newEntity.PhoneNumber = entities[i].PhoneNumber;

                dynamic item = col2range.Item(i + 1);
                newEntity.UnitSales = Convert.ToInt32(item.Value);

                newEntities[i] = newEntity;
            }

            CustomerList.ItemsSource = newEntities;
            CustomerList.SelectedIndex = Convert.ToInt32(rowValue) - 1;

            UpdateNotification.Text = "Data updated from Excel spreadsheet";
        }
    }
}
